//taken from q3base folder scripts shader
models/mapobjects/gratelamp/gratetorch2b
{
    cull disable
    
        {
                map models/mapobjects/gratelamp/gratetorch2b.tga
                alphaFunc GE128
		depthWrite
		rgbGen vertex
        }


}

models/mapobjects/tree2/branch2
{
  surfaceparm nolightmap
  surfaceparm trans	
  surfaceparm nomarks	
  cull none
  sort 10
	{
		clampmap models/mapobjects/tree2/branch2.tga
		blendFunc GL_ZERO GL_ONE_MINUS_SRC_COLOR        
	}
}


models/mapobjects/wallhead/femhead
{
        deformVertexes wave 100 sin 0 .7 0 .2
        //deformVertexes wave 100 sin 0 1 1 .1
        cull disable

        {
                map models/mapobjects/wallhead/femhead3.tga
                rgbGen vertex
        }
	{
//animMap 0.5 models/mapobjects/wallhead/femhead4.tga
//models/mapobjects/wallhead/femhead2.tga
                map models/mapobjects/wallhead/femhead4.tga
		blendFunc	GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
		alphaGen	wave sin 0 1 1 .1
// alphaGen	wave triangle 0 .7 0 .2
                rgbGen vertex
	}	
	
}


//from a french guy about making fur texture usable for grass "real" looking
//i work hard on this one to understand
textures/fur/grass_base
{
	q3map_cloneshader textures/fur/grass_fur
	{
		map $lightmap
	}
	{
		map textures/fur/grass_base.tga
		blendFunc GL_DST_COLOR GL_ZERO
	}
}

// ------------------------------------------------------------------------------
// fur texture
// ------------------------------------------------------------------------------
textures/fur/grass_fur
{
	// remplacez texture_fur.q3map.tga par le nom de votre texture
	q3map_lightimage textures/fur/grass_fur.q3map.tga
	
	// On ne touche pas !
	q3map_notjunc
	q3map_nonplanar
	q3map_bounce 0.0
	q3map_shadeangle 120

	// format: q3map_fur <layers> <offset> <fade>
	// format: q3map_fur <nombre de couches> <hauteur> <adoucissement>
	// <nombre de couches> Augmentez/diminuez cette valeur si 
	// texture_fur.tga est respectivement plus opaque/transparente
	// <hauteur> Hauteur de la fourrure.
	// <adoucissement> plus la valeur est leve, plus la fourrure sera floue
	q3map_fur 8 1.25 0.1
	
	surfaceparm trans
	surfaceparm pointlight
	surfaceparm alphashadow
	surfaceparm nonsolid
	surfaceparm noimpact
	
	// cull none
	nomipmaps
	
	{
		map textures/fur/grass_fur.tga
		//alphaFunc GE128
		blendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
		rgbGen vertex
	}
}

// ------------------------------------------------------------------------------
// q3map 2 fur demo shader
// this is expensive, so use it sparingly :)
// note, this can be used with terrain shaders to have a layer with grass...
//
// ydnar@shaderlab.com
// ------------------------------------------------------------------------------

textures/fur/sky
{
	q3map_surfacelight 100
	q3map_sun 1 .85 0.5 65 -30 60
	
	surfaceparm noimpact
	surfaceparm nolightmap
	surfaceparm sky
	{
		map textures/fur/sky.tga
	}
}

// ------------------------------------------------------------------------------
// base texture
// ------------------------------------------------------------------------------

textures/fur/pink_base
{
	q3map_cloneshader textures/fur/pink_fur
	deformVertexes wave 20 sin 3 2 .1 0.1
	{
		map $lightmap
	}
	{
		map textures/fur/pink_base.tga
		blendFunc GL_DST_COLOR GL_ZERO
	}
}

// ------------------------------------------------------------------------------
// fur texture
// ------------------------------------------------------------------------------
textures/fur/pink_fur
{
	// remplacez texture_fur.q3map.tga par le nom de votre texture
	q3map_lightimage textures/fur/pink_fur.q3map.tga
	
	// On ne touche pas !
	q3map_notjunc
	q3map_nonplanar
	q3map_bounce 0.0
	q3map_shadeangle 120

	// format: q3map_fur <layers> <offset> <fade>
	// format: q3map_fur <nombre de couches> <hauteur> <adoucissement>
	// <nombre de couches> Augmentez/diminuez cette valeur si 
	// texture_fur.tga est respectivement plus opaque/transparente
	// <hauteur> Hauteur de la fourrure.
	// <adoucissement> plus la valeur est leve, plus la fourrure sera floue
	q3map_fur 8 1.25 0.1
	
	surfaceparm trans
	surfaceparm pointlight
	surfaceparm alphashadow
	surfaceparm nonsolid
	surfaceparm noimpact
	
	// cull none
	nomipmaps
	
	{
		map textures/fur/pink_fur.tga
		//alphaFunc GE128
		blendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
		rgbGen vertex
	}
}

textures/_sgobjs/sgsky
{ 
qer_editorimage textures/_sgobjs/sgsky.tga 
//q3map_bounce .3 
q3map_globaltexture  
q3map_sun .984314 .862745 .490196 400 40 40 
q3map_surfaceLight 300
q3map_backsplash 0 0 
surfaceparm sky 
surfaceparm nolightmap 
surfaceparm noimpact 
skyparms env/sgskybox/sgsky - - 
} 

textures/_sgobjs/sgsky1
{ 
q3map_lightRGB 0.923568 0.959106 1.000000
q3map_skylight 20 5
surfaceparm nomarks
surfaceparm sky 
surfaceparm noimpact
surfaceparm nodlight
q3map_lightmapFilterRadius 0 8
q3map_sunExt 1.000000 0.997119 0.857641 80 120 70 2 2
surfaceparm nolightmap
q3map_nolightmap
skyparms env/sgskybox1/sgsky1 - - 
}

textures/_sgobjs/sgsky2
{ 
qer_editorimage textures/_sgobjs/sgsky2.tga 
//q3map_globaltexture

//This tells the engine what color to make the light that the sky will cast
q3map_lightRGB 0.923568 0.959106 1.000000

//This is the sky light. The first value is the amount of light that the sky will cast.
//This should be lower than the amount of light that the sun is casting.
//This is only a filler light to make outdoor lighting seem a bit more real looking.
//The second value is the iterations.
//This value should not go below 3 if you want quality and speed in your compiles.
//Higher numbers make it better looking but a longer compile.
q3map_skylight 80 5

//This will make the it so that no decal marks from explosions
//and laser blasts are left on the sky box.
surfaceparm nomarks

surfaceparm sky 

//This will stop explosions from impacting on this surface. Such as missiles and lasers.
surfaceparm noimpact

//This line stops dynamic lights from hitting the skybox.
surfaceparm nodlight

//This line applies a filter blur to the lighting.
//This is good if you are looking to make shadows smoother.
//I found it to add a nice touch to any outdoor map.
//It also helps get rid of the stadium light affect.
q3map_lightmapFilterRadius 0 8

//This line actually makes the shader emit a sun light.
//Please note that this is q3map_sunExt and not just q3map_sun.
//Q3map_sunExt is much better.
//The first 3 values are Red Green Blue color values.
//The 4th value is the amount of light that it casts.
//This should be higher than the q3map_skylight value.
//The 5th line is the sun's heading.
//This is the direction that the light will come from in a degree value.
//The 6th line is the sun's altitude.
//This is also in degrees ranging from 90 to -90, 0 being the horizon 
//and 90 up and -90 down. The 7th value is the deviance, the number of degrees 
//for the half-shadow. General values up to 2 or 3 are acceptable.
//The real sun has a solid angle of about half a degree.
//The 8th value is the samples, which are the number of random jitters distributed
//over the solid arc (~16).
q3map_sunExt 1.000000 0.997119 0.857641 400 120 35 2 2

surfaceparm nolightmap
q3map_nolightmap

//This tells the engine where to find the 6 images. You should put the path to your 
//skybox images here. The next number is the cloud height. This is only used if you 
//have a cloud layer. So leave it at whatever. The last - is non-functional. It was 
//supposed to be like a portalsky kind of but it never got coded.
skyparms env/sgskybox2/sgsky2 - - 
} 

textures/_sgobjs/sgsky3
{ 
qer_editorimage textures/_sgobjs/sgsky3.tga 
q3map_lightRGB 0.923568 0.959106 1.000000
q3map_skylight 80 5
surfaceparm sky 
surfaceparm noimpact
surfaceparm nodlight
q3map_lightmapFilterRadius 0 8
q3map_sunExt 1.000000 0.997119 0.857641 400 120 35 2 2
surfaceparm nolightmap
q3map_nolightmap
skyparms env/sgskybox3/sgsky3 - - 
} 

textures/_sgobjs/sgsky4
{ 
qer_editorimage textures/_sgobjs/sgsky4.tga 
q3map_lightRGB 0.923568 0.959106 1.000000
q3map_skylight 80 5
surfaceparm sky 
surfaceparm noimpact
surfaceparm nodlight
q3map_lightmapFilterRadius 0 8
q3map_sunExt 1.000000 0.997119 0.857641 400 120 35 2 2
surfaceparm nolightmap
q3map_nolightmap
nopicmip
nomipmaps
{
	map textures/null_beach/sky_clouds.tga
	tcMod scale 3 3
	tcMod scroll 0.005 -0.0125
	rgbGen identityLighting
}
	{
		clampmap textures/null_beach/sky_arc_masked.tga
		blendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
		tcMod scale 0.956 0.956	// note for RTCW, this line should be commented out if the sky is knackered
		tcMod transform 1 0 0 1 -1 -1
		rgbGen identityLighting
	}
skyparms env/sgskybox4/sgsky4 - - 
}

textures/mirror/mirrortut
{
	qer_editorimage textures/mirror/mirrortut.tga
	surfaceparm nolightmap
	portal
	{
		map textures/mirror/mirrortut.tga
		blendfunc GL_ONE GL_ONE_MINUS_SRC_ALPHA
		depthWrite
	}      
}

textures/_sgobjs/sleepguyt1.jpg
{
qer_editorimage textures/_sgobjs/sleepguyt1.jpg
q3map_surfacelight 2500
light 1
Surfaceparm nomarks
{
map $lightmap
RgbGen identit
}
}

textures/_sgobjs/treviftold
{
	qer_editorimage textures/_sgobjs/treviftold.jpg
	q3map_globaltexture
	surfaceparm nonsolid
	surfaceparm water
	cull disable
	deformVertexes wave 100 sin 3 2 .1 0.1
	{
		map textures/_sgobjs/treviftold.jpg
		tcmod scale .2 .2
		tcmod scroll .04 .03
		tcMod turb 0 .1 0 .01
		blendFunc GL_ONE GL_ZERO
		rgbGen identity
	}
	{
		map textures/_sgobjs/treviftold.jpg
		blendfunc blend
		tcMod turb 0 .2 0 .1
	}
}

textures/_sgobjs/trevift
{
	qer_editorimage textures/_sgobjs/trevift.jpg
	deformVertexes wave 5 sin .5 .5 .1 0.1
	qer_trans 0.6
	surfaceparm nonsolid
	surfaceparm trans
	surfaceparm water
	qer_nocarve
	surfaceparm noimpact
	surfaceparm nolightmap
	q3map_globaltexture
	cull disable
	{
		map textures/_sgobjs/trevift.jpg
		blendFunc GL_dst_color GL_one
		rgbGen identity
	}
	{
		map $lightmap
		blendFunc GL_dst_color GL_zero
		rgbgen identity		
	}
}

textures/_sgobjs/trevift2
{
	qer_editorimage textures/_sgobjs/trevift2.jpg
	deformVertexes wave 40 sin 4 2 .2 0.2
	qer_trans 0.50
	surfaceparm nonsolid
	surfaceparm trans
	surfaceparm water
	qer_nocarve
	surfaceparm noimpact
	surfaceparm nolightmap
	cull none
	{
		map textures/_sgobjs/trevift2.jpg
		tcMod turb 0.1 0.0 0.0 .1
	}
}


//cut and paste  from willy duck watercaulk, just changed texture in editor
textures/_sgobjs/sg_watercaulk
{
	qer_editorimage textures/liquids/clear_ripple3.tga
	qer_trans 0.3
	qer_nocarve
	surfaceparm nodraw
	surfaceparm nolightmap
	surfaceparm trans
	surfaceparm nomarks
	surfaceparm water
	surfaceparm noimpact
}

textures/_sgobjs/water_fount
	{
		qer_editorimage textures/liquids/clear_ripple3.tga
		qer_trans .5
		q3map_globaltexture
		surfaceparm trans
		surfaceparm nonsolid
		surfaceparm water
	
		cull disable
		//deformVertexes wave 40 sin 4 2 .2 0.2	
		{ 
			map textures/liquids/pool3d_5.tga
			blendFunc GL_dst_color GL_one
			rgbgen identity
			tcmod scale .5 .5
			tcmod transform 1.8 0 1.8 1 1 2
			tcmod scroll -.05 .001
		}
	
		{ 
			map textures/liquids/pool3d_6.tga
			blendFunc GL_dst_color GL_one
			rgbgen identity
			tcmod scale .5 .5
			tcmod transform 0 1.8 1 1.8 2 1
			tcmod scroll .025 -.001
		}

		{ 
			map textures/liquids/pool3d_3.tga
			blendFunc GL_dst_color GL_one
			rgbgen identity
			tcmod scale .25 .8
			tcmod scroll .001 .025
		}
	
		{
			map $lightmap
			blendFunc GL_dst_color GL_zero
			rgbgen identity		
		}
}

textures/_sgobjs/clear_ripple3b
	{
		qer_editorimage textures/liquids/clear_ripple3.tga
		qer_trans .5
		q3map_globaltexture
		surfaceparm trans
		surfaceparm nonsolid
		surfaceparm water
	
		cull disable
		//deformVertexes wave 180 sin 1.8 1 0 .8
		deformVertexes wave 40 sin 4 2 .2 0.2	
		{ 
			map textures/liquids/pool3d_5.tga
			blendFunc GL_dst_color GL_one
			rgbgen identity
			tcmod scale .5 .5
			tcmod transform 1.8 0 1.8 1 1 2
			tcmod scroll -.05 .001
		}
	
		{ 
			map textures/liquids/pool3d_6.tga
			blendFunc GL_dst_color GL_one
			rgbgen identity
			tcmod scale .5 .5
			tcmod transform 0 1.8 1 1.8 2 1
			tcmod scroll .025 -.001
		}

		{ 
			map textures/liquids/pool3d_3.tga
			blendFunc GL_dst_color GL_one
			rgbgen identity
			tcmod scale .25 .8
			tcmod scroll .001 .025
		}
	
		{
			map $lightmap
			blendFunc GL_dst_color GL_zero
			rgbgen identity		
		}
}


textures/_sgobjs/InvLadder
{
	qer_editorimage textures/_sgobjs/GoldBricks.jpg
	qer_trans 0.20
	surfaceparm noimpact
	surfaceparm nomarks
	surfaceparm playerclip
	surfaceparm nodraw
	surfaceparm ladder
}

// Etape 1 : Shader de Terrain rfrence
textures/terrain/texture_base
{
	// Obligatoire
	q3map_tcGen ivector ( 256 0 0 ) ( 0 256 0 )
	// projette la texture toutes les 256 units suivant les axes X et Y
	q3map_lightmapaxis z
	// projette le lightmap le long de l'axe Z (haut/bas)
	
	// Optionel
	q3map_lightmapmergable
	// fusionne tout le terrain en un seul lightmap sans coupures
	q3map_lightmapsamplesize 32
	// met la taille du sample du lightmap  32 
	// (2x taille par dfaut) pour conomiser de la RAM
}

// Etape 2 : Shader de Terrain unique
textures/terrain/texture_0
{
	q3map_baseshader textures/terrain/texture_base
	q3map_terrain
	// on rcupre toutes les proprits du shader de 
	// rfrence par hritage grce au keyword q3map_baseshader
	{
		map textures/terrain/texture_0.tga
	}
	{
		map $lightmap
		blendFunc GL_DST_COLOR GL_ZERO
		// on applique le lightmap
	}
}

textures/terrain/texture_1
{
	q3map_baseshader textures/terrain/texture_base
	q3map_terrain
	// on rcupre toutes les proprits du shader de 
	// rfrence par hritage grce au keyword q3map_baseshader
	{
		map textures/terrain/texture_1.tga
	}
	{
		map $lightmap
		blendFunc GL_DST_COLOR GL_ZERO
		// on applique le lightmap
	}
}

// Etape 3 : Shader de Terrain pour la fusion des deux textures
textures/terrain/texture_0to1
{
	q3map_baseshader textures/terrain/texture_base
	{
		map textures/terrain/texture_0.tga
	}
	{
		map textures/terrain/texture_1.tga
		blendFunc GL_SRC_ALPHA GL_ONE_MINUS_SRC_ALPHA
		alphaGen vertex
		// phase de mlange
	}
	{
		map $lightmap
		blendFunc GL_DST_COLOR GL_ZERO
		// on applique le lightmap par-dessus
	}
}

//For sky in water in island map
textures/_sgobjs/sg_watersky
{
	qer_editorimage textures/null_beach/sand_3.tga
	{
		map textures/null_beach/sand_3.tga
	}
	surfaceparm nodlight
	surfaceparm nolightmap
	surfaceparm nomarks
	surfaceparm noimpact
}